#include "definition.h" 
#include "PinMapping.h"
#include "SAB.h"
#include "views.h"

SAB sab;

unsigned long currentMs = 0, batteryMs = 0, buttonMs = 0;
int mySize = 0;
unsigned char curView = 0;
DateTimePacket dtp = {sab.getRtcManager().getDateTime(), sab.getSdCardManager().getSize(GBYTE), sab.getPowerInfo()};

void setup() {
  // put your setup code here, to run once:
  Serial.println("Starting setup");
  pinMode(GPIO_0, INPUT);
  sab.getScreenManager().addView(&(view_1), &dtp, 0);
  sab.getScreenManager().addView(&(view_2), NULL, 1);

  /*Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(GBYTE));
  Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(GBIT));
  Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(MBYTE));
  Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(MBIT));
  Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(KBYTE));
  Serial.print("SD size : ");Serial.println(sab.getSdCardManager().getSize(KBIT));*/
  sab.getScreenManager().displayView(curView);
  Serial.println("End setup");
}

void loop() {
  if(millis() - currentMs > 1000)
  {
    currentMs = millis();
    dtp.dateTime = sab.getRtcManager().getDateTime();
    sab.getScreenManager().displayView();
  }

  if(millis() - batteryMs > 10000)
  {
    batteryMs = millis();
    dtp.powerInfo = sab.getPowerInfo();
  }
    

  if(digitalRead(GPIO_0) == 0 && millis() - buttonMs > 500)
  {
    buttonMs = millis();
    Serial.println("Changing view");
    //sab.getRtcManager().setDateTime(DateTime(2019,3,9,19,34,0));
    curView++;
    curView %= 2;
    sab.getScreenManager().displayView(curView);
  }
    
}
